## freedombox 26.4

=== Makefile ===
DJANGO_ADMIN := django-admin
INSTALL := install
PYTHON := python3
PYTEST_ARGS :=
CP_ARGS := --no-dereference --preserve=mode,timestamps --reflink=auto

ENABLED_APPS_PATH := $(DESTDIR)/usr/share/freedombox/modules-enabled

DISABLED_APPS_TO_REMOVE := \
    apps \
    coquelicot \
    diaspora \
    monkeysphere \
    owncloud \
    system \
    xmpp \
    disks \
    udiskie \
    restore \
    repro \
    tahoe \
    mldonkey \
    i2p \
    ttrss \
    sso

APP_FILES_TO_REMOVE := $(foreach app,$(DISABLED_APPS_TO_REMOVE),$(ENABLED_APPS_PATH)/$(app))

REMOVED_FILES := \
    $(DESTDIR)/etc/apt/preferences.d/50freedombox3.pref \
    $(DESTDIR)/etc/apache2/sites-available/plinth.conf \
    $(DESTDIR)/etc/apache2/sites-available/plinth-ssl.conf \
    $(DESTDIR)/etc/security/access.d/10freedombox-performance.conf \
    $(DESTDIR)/etc/security/access.d/10freedombox-security.conf

DIRECTORIES_TO_CREATE := \
    $(DESTDIR)/var/lib/plinth \
    $(DESTDIR)/var/lib/plinth/sessions

STATIC_FILES_DIRECTORY := $(DESTDIR)/usr/share/plinth/static
BIN_DIR := $(DESTDIR)/usr/bin
LIB_DIR := $(DESTDIR)/usr/lib

FIND_ARGS := \
    -not -iname "*.log" \
    -not -iname "*.pid" \
    -not -iname "*.py.bak" \
    -not -iname "*.pyc" \
    -not -iname "*.pytest_cache" \
    -not -iname "*.sqlite3" \
    -not -iname "*.swp" \
    -not -iname "\#*" \
    -not -iname ".*" \
    -not -iname "sessionid*" \
    -not -iname "~*" \
    -not -iname "django-secret.key" \
    -not -iwholename "*/.mypy_cache/*"


ROOT_DATA_FILES := $(shell find data -type f $(FIND_ARGS))
MODULE_DATA_FILES := $(shell find $(wildcard plinth/modules/*/data) -type f $(FIND_ARGS))

update-translations:
	$(DJANGO_ADMIN) makemessages --all --domain django --keep-pot \
		--verbosity=1 --ignore conftest.py --ignore doc --ignore build \
		--ignore htmlcov --ignore screenshots --ignore debian --ignore \
		actions --ignore preseed --ignore static --ignore data \
		--settings plinth.settings --pythonpath .

configure:
	# Nothing to do

build:
	# Compile translations
	$(DJANGO_ADMIN) compilemessages --verbosity=1

	# Build documentation
	$(MAKE) -C doc -j 8

	# Build .whl package
	rm -f dist/plinth-*.whl
	$(PYTHON) -m build --no-isolation --skip-dependency-check --wheel

install:
	# Drop removed apps
	rm -f $(APP_FILES_TO_REMOVE)

	# Drop removed configuration files
	rm -f $(REMOVED_FILES)

	# Create data directories
	for directory in $(DIRECTORIES_TO_CREATE) ; do \
	    $(INSTALL) -d $$directory ; \
	done

	# Python package
	temp=$$(mktemp -d) && \
        lib_dir=$$($(PYTHON) -c 'import sysconfig; print(sysconfig.get_paths(scheme="deb_system")["purelib"])') && \
	$(PYTHON) -m pip install dist/plinth-*.whl --break-system-packages \
            --no-deps --no-compile --no-warn-script-location \
            --ignore-installed --target=$${temp} && \
        $(INSTALL) -d $(DESTDIR)$${lib_dir} && \
	rm -rf $(DESTDIR)$${lib_dir}/plinth $(DESTDIR)$${lib_dir}/plinth*.dist-info && \
        mv $${temp}/plinth $${temp}/plinth*.dist-info $(DESTDIR)$${lib_dir} && \
	rm -f $(DESTDIR)$${lib_dir}/plinth*.dist-info/licenses/COPYING.md && \
	rm -f $(DESTDIR)$${lib_dir}/plinth*.dist-info/direct_url.json && \
        $(INSTALL) -D -t $(BIN_DIR) bin/plinth
	$(INSTALL) -D -t $(LIB_DIR)/freedombox bin/freedombox-privileged
	$(INSTALL) -D -t $(BIN_DIR) bin/freedombox-cmd
	$(INSTALL) -D -t $(BIN_DIR) bin/freedombox-change-password

	# Static web server files
	rm -rf $(STATIC_FILES_DIRECTORY)
	$(INSTALL) -d $(STATIC_FILES_DIRECTORY)
	cp $(CP_ARGS) --recursive static/* $(STATIC_FILES_DIRECTORY)

	# System data files
	for file in $(ROOT_DATA_FILES) ; do \
	    target=$$(dirname $(DESTDIR)$$(echo $${file} | sed -e 's|^data||')) ; \
	    $(INSTALL) --directory --mode=755 $${target} ; \
	    cp $(CP_ARGS) $${file} $${target} ; \
	done
	for file in $(MODULE_DATA_FILES) ; do \
	    target=$$(dirname $(DESTDIR)$$(echo $${file} | sed -e 's|^plinth/modules/[^/]*/data||')) ; \
	    $(INSTALL) --directory --mode=755 $${target} ; \
	    cp $(CP_ARGS) $${file} $${target} ; \
	done

	# Documentation
	$(MAKE) -C doc install

check: check-type check-code check-doc check-tests

# Run the main test suite
check-tests:
	$(PYTHON) -m pytest $(PYTEST_ARGS)

# Tests with coverage report
check-tests-cov:
	$(PYTHON) -m pytest $(PYTEST_ARGS) --cov=plinth \
	    --cov-report=html:./htmlcov --cov-report=term

# Code quality checking using flake8
check-code:
	$(PYTHON) -m flake8 plinth container

# Static type checking using mypy
check-type:
	$(PYTHON) -m mypy .

# Use doctest for check the wikiparser in doc directory
check-doc:
	$(PYTHON) -m doctest doc/scripts/wikiparser.py

clean:
	make -C doc clean
	rm -rf Plinth.egg-info
	find plinth/locale -name *.mo -delete

define DEVELOP_SERVICE_CONF
[Service]
Environment=FREEDOMBOX_DEVELOP=1
Environment=PYTHONPATH=/freedombox/
endef
export DEVELOP_SERVICE_CONF

define DEVELOP_LOGS_SCRIPT
#!/usr/bin/bash

set -e
set -x

journalctl --follow --unit=plinth.service --unit=freedombox-privileged.service
endef
export DEVELOP_LOGS_SCRIPT

# Run basic setup for a developer environment (VM or container)
provision-dev:
	# Install newer build dependencies if any
	apt-get update
	DEBIAN_FRONTEND=noninteractive apt-get build-dep --yes .

	# Install latest code over .deb
	$(MAKE) build install

	# Configure privileged and web daemon for development setup
	mkdir -p /etc/systemd/system/freedombox-privileged.service.d/
	echo "$$DEVELOP_SERVICE_CONF" > /etc/systemd/system/freedombox-privileged.service.d/develop.conf
	mkdir -p /etc/systemd/system/plinth.service.d/
	echo "$$DEVELOP_SERVICE_CONF" > /etc/systemd/system/plinth.service.d/develop.conf

	# Create a command to easily watch service logs
	echo "$$DEVELOP_LOGS_SCRIPT" > /usr/bin/freedombox-logs
	chmod 755 /usr/bin/freedombox-logs

	# Reload newer systemd units, ignore failure
	-systemctl daemon-reload

	# Enable privileged daemon
	-systemctl stop freedombox-privileged.service

	-test -d /run/systemd/system && \
		systemctl enable --now freedombox-privileged.socket

	# Enable and restart plinth service if it is running
	-systemctl enable plinth.service
	-systemctl restart plinth.service

	# Stop any ongoing upgrade, ignore failure
	-killall -9 unattended-upgr

	# Fix any broken packages
	dpkg --configure -a
	apt-get -f install
	apt-get update

	# Install new packages needed by essential apps. Don't uninstall
	# freedombox in case new dependencies conflict with old dependencies
	apt-mark hold freedombox
	DEBIAN_FRONTEND=noninteractive apt-get install --no-upgrade --yes \
	    $$(sudo -u plinth ./run --develop --list-dependencies)
	apt-mark unhold freedombox

	# DNS resolution may be broken by upgrade to systemd-resolved. See
	# #1079819 and ##1032937.
	-systemctl restart systemd-resolved
	-nmcli general reload dns-rc

	# Install additional packages
	DEBIAN_FRONTEND=noninteractive apt-get install --yes ncurses-term \
	    sshpass bash-completion

wait-while-first-setup:
	while [ x$$(curl -k https://localhost/freedombox/status/ 2> /dev/null | \
	    json_pp 2> /dev/null | grep 'is_first_setup_running' | \
            tr -d '[:space:]' | cut -d':' -f2 ) != 'xfalse' ] ; do \
	    sleep 1; echo -n .; done

.PHONY: \
    build \
    check \
    check-code \
    check-doc \
    check-type \
    check-tests \
    check-tests-cov \
    clean \
    configure \
    install \
    provision \
    update-translations \
    wait-while-first-setup

=== debian/changelog ===
freedombox (26.4) unstable; urgency=medium

  [ Joseph Nuthalapati ]
  * ui: Dismiss notifications without page reload

  [ Sunil Mohan Adapa ]
  * ui: Refactor notification delete buttons to avoid repeating code
  * ui: Add animation for notification dismissal
  * actions, privileged_daemon: Drop some unused global statements
  * backups: Avoid some repeated text in form help text
  * backups: Fix issue with Javascript in add remote location form
  * backups: Show/hide form elements instead of disabling for simplicity
  * backups: Tweak appearance of add remote location form
  * backups: tests: Simplify functional test using more classes
  * backups: Minor refactoring
  * backups: Simplify handling of migration to SSH keys
  * backups: Create .ssh folder before creating SSH key
  * backups: Fix showing proper error for incorrect passphrase
  * backups: Create a better comment in the generated SSH key file
  * backups: Fix type checking errors
  * action_utils: Implement utility to change umask temporarily
  * quassel: Explicitly set permissions on the domain configuration file
  * letsencrypt: When copying certificate reset the umask reliably
  * doc/dev: Set new theme for developer documentation
  * action_utils: Fix issue with type checking a generator
  * tests: functional: Increase systemd rate limits for starting units
  * js: When page load fails during install, show it to user
  * tests: functional: Fix reloading error page during install/uninstall
  * locale/de: Fix several translations with HTML links (German)
  * locale/bg: Fix several translations with HTML links (Bulgarian)
  * bin: Add tool to change FreedomBox password in Django database
  * ejabberd: Fix setting up certificates for multiple domains
  * gitweb: Fix issue with running post init due to missing method
  * wireguard: Fix format when showing multiple endpoints of the server
  * wireguard: Fix showing default route setting in server edit form
  * wireguard: Show status of default route in server information page
  * wireguard: Accept/use netmask with IP address for server connection
  * README/HACKING: Update weblate project path to /freedombox
  * *: Remove some absolute file paths in SVGs
  * matrixsynapse: Update apache config to proxy Synapse client API
  * cfg: Drop unused config_dir option
  * cfg: Drop unused actions_dir option
  * Vagrantfile: Drop unnecessary sudo configuration for actions
  * pyproject: Use new format to specify licenses
  * action_utils: Drop support for link-local IPv6 addresses
  * debian: Ensure that gbp creates a clean tarball prior to build
  * syncthing: tests: Fix tests by allowing rapid restarts
  * web_server: Log requests to WSGI app
  * *: Update URL base from /plinth to /freedombox
  * tests: functional: Fix expecting FreedomBox to be home page
  * web_framework: Allow FreedomBox apps to override templates
  * templates: Allow building pages without navigation bar and footer
  * apache: Preserve host header when proxying to service
  * oidc: New app to implement OpenID Connect Provider
  * oidc: Style the page for authorizing an OIDC app
  * apache: Implement protecting apps using OpenID Connect
  * featherwiki: Use OpenID Connect instead of pubtkt based SSO
  * syncthing: Use OpenID Connect instead of pubtkt based SSO
  * searx: Use OpenID Connect instead of pubtkt based SSO
  * rssbridge: Use OpenID Connect instead of pubtkt based SSO
  * email: Use OpenID Connect instead of pubtkt based SSO
  * calibre: Use OpenID Connect instead of pubtkt based SSO
  * deluge: Use OpenID Connect instead of pubtkt based SSO
  * gitweb: Use OpenID Connect instead of pubtkt based SSO
  * tiddlywiki: Use OpenID Connect instead of pubtkt based SSO
  * wordpress: Use OpenID Connect instead of pubtkt based SSO when private
  * transmission: Use OpenID Connect instead of pubtkt based SSO
  * doc/dev: Use OpenID Connect instead of pubtkt based SSO
  * sharing: Use OpenID Connect instead of pubtkt based SSO
  * sso: Merge into users module, drop pubtkt related code
  * apache: Fix diagnosing URLs protected by OpenID Connect

  [ 大王叫我来巡山 ]
  * Translated using Weblate (Chinese (Simplified Han script))

  [ Burak Yavuz ]
  * Translated using Weblate (Turkish)

  [ Coucouf ]
  * Translated using Weblate (French)
  * Translated using Weblate (French)

  [ Besnik Bleta ]
  * Translated using Weblate (Albanian)

  [ Dietmar ]
  * Translated using Weblate (German)

  [ James Valleroy ]
  * backups: Generate SSH client key if needed
  * backups: Display SSH public key when adding remote
  * backups: Copy SSH client public key to remote
  * backups: Use SSH key instead of password
  * backups: Use selected SSH credential for remote
  * backups: Test adding/removing remote location
  * backups: Arrange form for adding remote location
  * backups: Migrate to SSH key auth when mounting
  * Translated using Weblate (Greek)
  * mumble: murmurd renamed to mumble-server
  * Translated using Weblate (Tamil)
  * locale: Update translation strings
  * doc: Fetch latest manual
  * apache: Fix check_url test

  [ Frederico Gomes ]
  * container: Align terminology in printed banner
  * wireguard: filter .local addresses from showClient view
  * wireguard: improved server section UX flow
  * wireguard: show server vpn ip in show client page
  * wireguard: Fix split tunneling
  * miniflux: Revert workaround for a packaging bug with DB connection
  * db: Create a utility to get credentials from dbconfig
  * miniflux: Get credentials from dbconfig-common directly

  [ Pierfrancesco Passerini ]
  * Translated using Weblate (Italian)

  [ Daniel Wiik ]
  * Translated using Weblate (Swedish)
  * Translated using Weblate (Swedish)

  [ kosagi ]
  * Translated using Weblate (Catalan)

  [ Jiří Podhorecký ]
  * Translated using Weblate (Czech)

  [ Isak ]
  * Translated using Weblate (Swedish)

  [ Βασίλης Χατζηκαμάρης ]
  * Translated using Weblate (Greek)

  [ Benedek Nagy ]


=== debian/control ===
Source: freedombox
Section: web
Maintainer: FreedomBox packaging team <freedombox-pkg-team@lists.alioth.debian.org>
Uploaders:
 Tzafrir Cohen <tzafrir@debian.org>,
 Piotr Ożarowski <piotr@debian.org>,
 Petter Reinholdtsen <pere@debian.org>,
 Sunil Mohan Adapa <sunil@medhas.org>,
 Nick Daly <Nick.M.Daly@gmail.com>,
 Federico Ceratto <federico@debian.org>,
 James Valleroy <jvalleroy@mailbox.org>,
Build-Depends:
 debhelper-compat (= 13),
 dblatex,
 dh-python,
 docbook-xsl,
 e2fsprogs,
 gir1.2-nm-1.0,
 libjs-bootstrap5,
 libjs-htmx,
# Older libjs-bootstrap5 does not have proper dependency on popper.js >= 2.0
 node-popper2,
 pybuild-plugin-pyproject,
 python3-all:any,
 python3-apt,
 python3-augeas,
 python3-bootstrapform,
 python3-build,
 python3-cherrypy3,
 python3-configobj,
 python3-cryptography,
 python3-dbus,
 python3-django,
 python3-django-axes,
 python3-django-captcha,
# Explictly depend on ipware as it is optional dependecy of django-axes
 python3-django-ipware,
 python3-django-oauth-toolkit,
 python3-django-stronghold,
 python3-gi,
 python3-markupsafe,
 python3-mypy,
 python3-pampy,
 python3-pexpect,
 python3-pip,
 python3-psutil,
 python3-pytest,
 python3-pytest-cov,
 python3-pytest-django,
 python3-pytest-runner,
 python3-requests,
 python3-ruamel.yaml,
 python3-setuptools,
 python3-systemd,
 python3-typeshed,
 python3-yaml,
 sshpass,
 xmlto,
 xsltproc
Standards-Version: 4.7.3
Homepage: https://salsa.debian.org/freedombox-team/freedombox
Vcs-Git: https://salsa.debian.org/freedombox-team/freedombox.git
Vcs-Browser: https://salsa.debian.org/freedombox-team/freedombox

Package: freedombox
Breaks:
# Ensure fuse gets replaced by fuse3 on upgrades from buster s.t. sshfs can be installed.
 fuse (<< 3),
# If ufw is installed, remove it. See issue 2247.
 ufw,
Architecture: all
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${freedombox:Depends},
 adduser,
 augeas-tools,
 bind9-dnsutils,
 curl,
 debconf,
 fonts-fork-awesome,
# sgdisk is used in storage app to expand GPT disks
 gdisk,
 gettext,
 gir1.2-glib-2.0,
 gir1.2-nm-1.0,
 javascript-common,
 ldapscripts,
# For gdbus used to call hooks into service
 libglib2.0-bin,
 libjs-bootstrap5,
 libjs-htmx,
 lsof,
 netcat-openbsd,
 network-manager,
# Older libjs-bootstrap5 does not have proper dependency on popper.js >= 2.0
 node-popper2,
 ppp,
 pppoe,
 python3-apt,
 python3-argon2,
 python3-augeas,
 python3-bootstrapform,
 python3-cherrypy3,
 python3-configobj,
 python3-dbus,
 python3-django,
 python3-django-axes,
 python3-django-captcha,
# Explictly depend on ipware as it is optional dependecy of django-axes
 python3-django-ipware,
 python3-django-oauth-toolkit,
 python3-django-stronghold,
 python3-gi,
 python3-markupsafe,
 python3-pampy,
 python3-pexpect,
 python3-psutil,
 python3-requests,
 python3-ruamel.yaml,
 python3-systemd,
 python3-yaml,
 sudo,
 wget,
# Ensure fuse gets replaced by fuse3 on upgrades from buster s.t. sshfs can be installed.
 fuse3,
Recommends:
# Temporarily moved from Depends due to piuparts bug #1010967.
 e2fsprogs,
# Wifi firmware
 firmware-ath9k-htc,
# FreedomBox documentation
 freedombox-doc-en,
 freedombox-doc-es,
# Resolve .local address using mDNS
 libnss-mdns,
# Resolve current hostname without /etc/hosts
 libnss-myhostname,
# Priority: standard
 locales,
# Precompiled data for all locales
 locales-all,
# Priority: standard
 openssh-client,
# Used by unattended-upgrades to check if running on AC power
 powermgmt-base,
# fuser, killall, pstree and other utilities
 psmisc,
Description: easy to manage, privacy oriented home server
 FreedomBox is designed to be your own inexpensive server at home. It runs free
 software and offers an increasing number of services ranging from a calendar or
 jabber server to a wiki or VPN. A web interface allows you to easily install
 and configure your apps.
 .
 This package provides the FreedomBox Service (Plinth) which installs,
 configures and manages all functions of FreedomBox. The service is managed
 using a web interface available at https://localhost/.

Package: freedombox-doc-en
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: easy to manage, privacy oriented home server - user manual (English)
 FreedomBox is designed to be your own inexpensive server at home. It runs free
 software and offers an increasing number of services ranging from a calendar or
 jabber server to a wiki or VPN. A web interface allows you to easily install
 and configure your apps.
 .
 This package contains the English user manual in HTML and PDF formats. It
 describes how to setup and use each application in FreedomBox and FreedomBox
 itself. It is accessible from Help menu in the FreedomBox web interface.

Package: freedombox-doc-es
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: easy to manage, privacy oriented home server - user manual (Spanish)
 FreedomBox is designed to be your own inexpensive server at home. It runs free
 software and offers an increasing number of services ranging from a calendar or
 jabber server to a wiki or VPN. A web interface allows you to easily install
 and configure your apps.
 .
 This package contains the Spanish user manual in HTML and PDF formats. It
 describes how to setup and use each application in FreedomBox and FreedomBox
 itself. It is accessible from Help menu in the FreedomBox web interface.
